/** 
*/
#if WAR_RFC2068
#ifndef WAR_SVR_PROTOCOL_HTTP_ENUMS_H
#define WAR_SVR_PROTOCOL_HTTP_ENUMS_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */


/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarSvrProtocolHttpEnums 
{
public:
    enum HttpVersionE
    {
        HTTP_1_1,
        HTTP_1_0,
        HTTP_INVALID
    };

    enum HttpMethodsE
    {
        HM_GET,
        HM_OPTIONS,
        HM_HEAD,
        HM_POST,
        HM_PUT,
        HM_DELETE,
        HM_TRACE,
        HM_INVALID
    };

    enum HttpReplyCodeE
    {
        // RFC 2068 reply messages
        HTTPR_CONTINUE_100 = 100,
        HTTPR_SWITCHING_PROTOCOLS = 101,
        HTTPR_OK = 200,
        HTTPR_CREATED = 201,
        HTTPR_ACCEPTED = 202,
        HTTPR_NON_AUTHORITATIVE_INFORMATION = 203,
        HTTPR_NO_CONTENT = 204,
        HTTPR_RESET_CONTENT = 205,
        HTTPR_PARTIAL_CONTENT = 206,
        HTTPR_MULTIPLE_CHOICES = 300,
        HTTPR_MOVED_PERMANENTLY = 301,
        HTTPR_MOVED_TEMPORARILY = 302,
        HTTPR_SEE_OTHER = 303,
        HTTPR_NOT_MODIFIED = 304,
        HTTPR_USE_PROXY = 305,
        HTTPR_BAD_REQUEST = 400,
        HTTPR_UNAUTHORIZED = 401,
        HTTPR_PAYMENT_REQUIRED = 402,
        HTTPR_FORBIDDEN = 403,
        HTTPR_NOT_FOUND = 404,
        HTTPR_METHOD_NOT_ALLOWED = 405,
        HTTPR_NOT_ACCEPTABLE = 406,
        HTTPR_PROXY_AUTHENTICATION_REQUIRED = 407,
        HTTPR_REQUEST_TIME_OUT = 408,
        HTTPR_CONFLICT = 409,
        HTTPR_GONE = 410,
        HTTPR_LENGTH_REQUIRED = 411,
        HTTPR_PRECONDITION_FAILED = 412,
        HTTPR_REQUEST_ENTITY_TOO_LARGE = 413,
        HTTPR_REQUEST_URI_TOO_LARGE = 414,
        HTTPR_UNSUPPORTED_MEDIA_TYPE = 415,
        HTTPR_INTERNAL_SERVER_ERROR = 500,
        HTTPR_NOT_IMPLEMENTED = 501,
        HTTPR_BAD_GATEWAY = 502,
        HTTPR_SERVICE_UNAVAILABLE = 503,
        HTTPR_GATEWAY_TIME_OUT = 504,
        HTTPR_HTTP_VERSION_NOT_SUPPORTED = 505,
    };

    enum HttpSvrMsgsE
    {
        HSM_BAD_IP, ///
        HSM_ACCESS_DENIED, ///
        HSM_GENERIC_FAIL, ///
        HSM_HEADER_TOO_LONG, ///
        HSM_NOT_IMPLEMENTED, ///
        INVALID
    };

    // LIFECYCLE
    // OPERATORS
    // OPERATIONS
    // CALLBACK
    // ACCESS
    // INQUIRY
    
protected:
private:
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_SVR_PROTOCOL_HTTP_ENUMS_H_ */
#endif // #if WAR_RFC2068
