/** 
*/

#if WAR_RFC2068
#ifndef WAR_WEBADM_SERVER_H
#define WAR_WEBADM_SERVER_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_SVR_PROTOCOL_HTTP_H
#   include "WarSvrProtocolHttp.h"
#endif

#ifndef WAR_SVR_DEFINITION_H
#   include "WarSvrDefinition.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */



#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarWebadmServer : 
public WarSvrProtocolHttp
{
public:
    // LIFECYCLE
    
    /**
    * Default constructor.
    */
    WarWebadmServer(war_socket_io_ptr_t& companionPtr,
        WarSvrDefinition& svrDefinion);
    
    // OPERATORS
    // OPERATIONS
    // CALLBACK
    // ACCESS
    // INQUIRY
    
protected:
    ~WarWebadmServer();

    // HTTP Auth
    virtual void VerifyHttpAuth() const throw(WarException);

    // HTTP Request verification
    virtual void VerifyHttpRequest() const throw(WarException);

     // HTTP request callbacks

    virtual void OnGetRequest(war_ccstr_t contentData, 
        const contentlen_t contentLength)
        throw(WarException);

private:
};

typedef WarSvrDefinitionImpl<WarWebadmServer> WarSvrDefinitionWebadm;

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_WEBADM_SERVER_H_ */
#endif // #if WAR_RFC2068
