#include "StdAfx.h"
#if WAR_RFC2068
#include "WarSvrProtocolHttpMsgs.h"   // class implemented

using namespace std;

/////////////////////////////// PUBLIC ///////////////////////////////////////

// NB: If you want to modify the server messages, do not
// modify here - make a textfile with your messages, as
// described in the documentation

static const war_ccstr_t Msgs[WarSvrProtocolHttpEnums::HttpSvrMsgsE::INVALID +1] =
{
    {"Your IP address is not welcome here."}, // HSM_BAD_IP
    {"Access denied."}, // HSM_ACCESS_DENIED
    {"The command failed."}, // HSM_GENERIC_FAIL
    {"HTTP header too long."}, // HSM_HEADER_TOO_LONG
    {"Request type not implemented."}, // HSM_NOT_IMPLEMENTED
    {""}
};

static const war_ccstr_t MacroNames[WarSvrProtocolHttpEnums::HttpSvrMsgsE::INVALID +1] = 
{
    {"HSM_BAD_IP"},
    {"HSM_ACCESS_DENIED"},
    {"HSM_GENERIC_FAIL"},
    {"HSM_HEADER_TOO_LONG"},
    {"HSM_NOT_IMPLEMENTED"},
    {"INVALID"}
};

const war_ccstr_t *WarSvrProtocolHttpMsgs::msDefMsg = Msgs;
const war_ccstr_t *WarSvrProtocolHttpMsgs::msMacroName = MacroNames;
const size_t WarSvrProtocolHttpMsgs::mArraySize
    = WarSvrProtocolHttpEnums::HttpSvrMsgsE::INVALID;

//============================= LIFECYCLE ====================================
//============================= OPERATORS ====================================
//============================= OPERATIONS ===================================
//============================= ACCESS     ===================================
//============================= INQUIRY    ===================================
/////////////////////////////// PROTECTED  ///////////////////////////////////
/////////////////////////////// PRIVATE    ///////////////////////////////////

#endif // #if WAR_RFC2068

