/** 
*/

#ifndef WAR_IF_WEBADM_H
#define WAR_IF_WEBADM_H

/* SYSTEM INCLUDES */


/* PROJECT INCLUDES */

#ifndef WAR_IF_SERVER_H
#   include "WarIfServer.h"
#endif

#ifndef WAR_IP_ACCESS_LIST_H
#   include "WarIpAccessList.h"
#endif

/* LOCAL INCLUDES */


/* FORWARD REFERENCES */

class WarIfServer;

#ifdef __cplusplus
extern "C" 
{
#endif
/****************** BEGIN OLD STYLE C spesific ********/


/****************** END OLD STYLE C spesific **********/
#ifdef __cplusplus 
}
#endif

/****************** BEGIN C++ spesific ****************/

#ifdef __cplusplus

class WarIfWebadm :
public WarSmartPointer
{
public:
    typedef std::basic_string<war_sysch_t> string_t;

    // LIFECYCLE
    // OPERATORS   
    // OPERATIONS

    void SetEnable(bool doEnable);
    void SetAddress(war_ccstr_t newHostname);
    void SetAccessGroup(war_ccsysstr_t newGroup);
    void SetIpAccessList(const WarIpAccessList& returnList);

    // CALLBACK
    // ACCESS
    // INQUIRY

    std::string GetAddress() const;
    string_t GetAccessGroup() const;
    bool IsEnabled() const;
    void GetIpAccessList(WarIpAccessList& returnList);
    
protected:
    friend class WarIfServer;
    WarIfWebadm(war_if_server_ptr_t& fromServer);
    ~WarIfWebadm();

private:
    WarWin32Registry mRegKey;
    war_if_server_ptr_t mServerPtr;
};

/* INLINE METHODS */

/* EXTERNAL REFERENCES */

typedef WarPtrWrapper<WarIfWebadm> war_if_webadm_ptr_t;

#endif /* __cplusplus */

/****************** END C++ spesific ******************/

#endif  /* WAR_IF_WEBADM_H_ */

